commit 3875b025a97ae667523bebf9f4cf157a8f5854ce
Author: Tom de Vries <tdevries@suse.de>
Date:   Fri Jan 28 10:28:59 2022 +0100

    [nvptx] Add uniform_warp_check insn
    
    On a GT 1030, with driver version 470.94 and -mptx=3.1 I run into:
    ...
    FAIL: libgomp.oacc-c/../libgomp.oacc-c-c++-common/parallel-dims.c \
      -DACC_DEVICE_TYPE_nvidia=1 -DACC_MEM_SHARED=0 -foffload=nvptx-none \
      -O2 execution test
    ...
    which minimizes to the same test-case as listed in commit "[nvptx]
    Update default ptx isa to 6.3".
    
    The problem is again that the first diverging branch is not handled as such in
    SASS, which causes problems with a subsequent shfl insn, but given that we
    have -mptx=3.1 we can't use the bar.warp.sync insn.
    
    Given that the default is now -mptx=6.3, and consequently -mptx=3.1 is of a
    lesser importance, implement the next best thing: abort when detecting
    non-convergence using this insn:
    ...
      { .reg.b32 act;
        vote.ballot.b32 act,1;
        .reg.pred uni;
        setp.eq.b32 uni,act,0xffffffff;
        @ !uni trap;
        @ !uni exit;
      }
    ...
    
    Interestingly, the effect of this is that rather than aborting, the test-case
    now passes.
    
    Tested on x86_64 with nvptx accelerator.
    
    gcc/ChangeLog:
    
    2022-01-31  Tom de Vries  <tdevries@suse.de>
    
            * config/nvptx/nvptx.c (nvptx_single): Use nvptx_uniform_warp_check.
            * config/nvptx/nvptx.md (define_c_enum "unspecv"): Add
            UNSPECV_UNIFORM_WARP_CHECK.
            (define_insn "nvptx_uniform_warp_check"): New define_insn.
    
    (cherry picked from commit f32f74c2e8cef5fe37af6d4e8d7e8f6b4c8ae9a8)

diff --git a/gcc/config/nvptx/nvptx.c b/gcc/config/nvptx/nvptx.c
index eec07fc3d13..0b67d544e48 100644
--- a/gcc/config/nvptx/nvptx.c
+++ b/gcc/config/nvptx/nvptx.c
@@ -4425,15 +4425,29 @@ nvptx_single (unsigned mask, basic_block from, basic_block to)
 	if (tail_branch)
 	  {
 	    label_insn = emit_label_before (label, before);
-	    if (TARGET_PTX_6_0 && mode == GOMP_DIM_VECTOR)
-	      warp_sync = emit_insn_after (gen_nvptx_warpsync (), label_insn);
+	    if (mode == GOMP_DIM_VECTOR)
+	      {
+		if (TARGET_PTX_6_0)
+		  warp_sync = emit_insn_after (gen_nvptx_warpsync (),
+					       label_insn);
+		else
+		  warp_sync = emit_insn_after (gen_nvptx_uniform_warp_check (),
+					       label_insn);
+	      }
 	    before = label_insn;
 	  }
 	else
 	  {
 	    label_insn = emit_label_after (label, tail);
-	    if (TARGET_PTX_6_0 && mode == GOMP_DIM_VECTOR)
-	      warp_sync = emit_insn_after (gen_nvptx_warpsync (), label_insn);
+	    if (mode == GOMP_DIM_VECTOR)
+	      {
+		if (TARGET_PTX_6_0)
+		  warp_sync = emit_insn_after (gen_nvptx_warpsync (),
+					       label_insn);
+		else
+		  warp_sync = emit_insn_after (gen_nvptx_uniform_warp_check (),
+					       label_insn);
+	      }
 	    if ((mode == GOMP_DIM_VECTOR || mode == GOMP_DIM_WORKER)
 		&& CALL_P (tail) && find_reg_note (tail, REG_NORETURN, NULL))
 	      emit_insn_after (gen_exit (), label_insn);
